class iaas::profile::heat (
#password modified
#  $password = undef,
  $password = hiera('iaas::profile::heat::password', undef),
  $encryption_key = hiera('iaas::profile::heat::encryption_key', undef),
  $public_interface = hiera('iaas::public_interface', undef),

#verbose, debug
  $verbose = hiera('iaas::verbose', undef),
  $debug = hiera('iaas::debug', undef),

  $region = hiera('iaas::region', undef),
  $endpoint = hiera('iaas::role::endpoint::main_address', undef),
#added $rhosts
  $rhosts = hiera('iaas::profile::rabbitmq::rhosts', undef),
  $rabbitmq_user = hiera('iaas::profile::rabbitmq::user', undef),
  $rabbitmq_password = hiera('iaas::profile::rabbitmq::password', undef),
) {
  include iaas::resources::connectors

  iaas::resources::database { 'heat': }

  class { '::heat::keystone::auth':
    password => $password,
    public_address => $endpoint,
    admin_address => $endpoint,
    internal_address => $endpoint,
    region => $region,
  }
  class { '::heat::keystone::auth_cfn':
    password => $password,
    public_address => $endpoint,
    admin_address => $endpoint,
    internal_address => $endpoint,
    region => $region,
  }

  class { '::heat':
#verbose, debug
    verbose => $verbose,
    debug => $debug,
    database_connection => $iaas::resources::connectors::heat,

#added rabbit_hosts
#    rabbit_host => $endpoint,
#    rpc_backend => "rabbit",
    rabbit_hosts => $rhosts,
    rabbit_userid => $rabbitmq_user,
    rabbit_password => $rabbitmq_password,
    auth_uri => "http://${endpoint}:5000/v2.0",
#Identity_uri - planed to be implemented#
#    identity_uri => "http://${endpoint}:35357",
    keystone_host => $endpoint,
    keystone_password => $password,
    mysql_module => '2.3',
    database_idle_timeout => 3600,
#region_name commented
#    region_name => $region,

#Set keystone_ec2_uri
#    keystone_ec2_uri => "http://${endpoint}:5000/v2.0/ec2tokens",
    keystone_ec2_uri => "http://${endpoint}:5000/v2.0",
  }

  class { '::heat::api':
    bind_host => $::facts["ipaddress_${public_interface}"],
  }
  class { '::heat::api_cfn':
    bind_host => $::facts["ipaddress_${public_interface}"],
  }
  class { '::heat::api_cloudwatch': 
    bind_host => $::facts["ipaddress_${public_interface}"],
  }

  class { '::heat::engine':
    auth_encryption_key => $encryption_key,
    heat_metadata_server_url => "http://${endpoint}:8000",
    heat_waitcondition_server_url => "http://${endpoint}:8000/v1/waitcondition",
    heat_watch_server_url => "http://${endpoint}:8003",
  }

  file { "/usr/bin/heat-keystone-setup-domain":
      mode   => 550,
      owner  => root,
      group  => root,
      source => "puppet:///modules/iaas/heat-keystone-setup-domain"
  } ->

  class { 'heat::keystone::domain':
#auth_url modified
#    auth_url => "http://${endpoint}:5000/v2.0",
    auth_url => "http://${endpoint}:35357/v2.0",
    keystone_admin => "heat",
    keystone_password => $password,
    keystone_tenant   => "services",
    domain_name => 'heat',
    domain_admin => 'heat_domain_admin',
    domain_password => 'heat_admin',
  }

#HAproxy variables commented
#  @@haproxy::balancermember { "heat_api_${::fqdn}":
#    listening_service => 'heat_api_cluster',
#    server_names => $::hostname,
#    ipaddresses => $::facts["ipaddress_${public_interface}"],
#    ports => '8004',
#    options => 'check inter 2000 rise 2 fall 5',
#  }
#
#  @@haproxy::balancermember { "heat_api_cfn_${::fqdn}":
#    listening_service => 'heat_api_cfn_cluster',
#    server_names => $::hostname,
#    ipaddresses => $::facts["ipaddress_${public_interface}"],
#    ports => '8000',
#    options => 'check inter 2000 rise 2 fall 5',
#  }
#
#  @@haproxy::balancermember { "heat_api_cw_${::fqdn}":
#    listening_service => 'heat_api_cw_cluster',
#    server_names => $::hostname,
#    ipaddresses => $::facts["ipaddress_${public_interface}"],
#    ports => '8003',
#    options => 'check inter 2000 rise 2 fall 5',
#  }
}
